#include <vector>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <map>
#include <set>

using namespace std;

vector<string> dane[7];

int cmode = 0;

char buf[640];

template<class T> int size(const T& s) { return s.size(); }

void zabierzLF(string& s) {
  while(size(s) > 0 && (s[size(s)-1] == 10 || s[size(s)-1] == 13))
    s.resize(size(s)-1);
  }

long long seed = 3195031;

#define P 2000000011

int myrand() {
  seed = ((long long)(seed) * 319607) % P;
  return seed;
  }

map<string, string> odpStud;
map<string, string> kodStud;
map<string, int>    ileOk;
map<string, int>    ileOdp;

map<string, vector<string> > pytania;  

map<string, char> ppodp;

set<string> kodByl;

int main() {
  for(int i=0; i<6; i++) myrand();
  FILE *f = fopen("exmix.tex", "rt");

  if(!f) {
    fprintf(stderr,"BLAD: brak pliku exmix.tex\n");
    exit(1);
    }

  while(!feof(f)) {
    fgets(buf, 640, f);
    if(buf[0] == '%' && buf[1] == 'E' && buf[2] == 'E') {
      cmode = atoi(buf+3);
      if(cmode < 0 || cmode > 6) cmode = 0;
      }
    else dane[cmode].push_back(buf);
    }
  fclose(f);
  
  for(int i=5; i<7; i++) for(int y=0; y<size(dane[i]); y++)
    zabierzLF(dane[i][y]);
  
  f = fopen("egzamin.tex", "wt");
  
  for(int y=0; y<size(dane[0]); y++)
    fprintf(f, "%s", dane[0][y].c_str());
  
  vector<pair<int, int> > v;
  
  for(int k1=0; k1<size(dane[5]); k1++) 
  for(int k2=0; k2<size(dane[6]); k2++) 
    v.push_back(make_pair(k1, k2));
    
  for(int i=0; i<size(v); i++) swap(v[i], v[myrand() % (i+1)]);

  string klucz, odp;
  
  for(int y=0; y<size(dane[2]); y++) {
    string s = dane[2][y];
    zabierzLF(s);
    ppodp[dane[2][y]] = s[size(s)-1];
    }
  
  for(int i=0; i<size(dane[5]); i++) 
  for(int j=0; j<i; j++) if(dane[5][i] == dane[5][j]) {
    printf("Powtorzona pierwsza litera klucza! Popraw przed uyciem!\n");
    return 0;
    }
  
  for(int i=0; i<size(dane[6]); i++) 
  for(int j=0; j<i; j++) if(dane[6][i] == dane[6][j]) {
    printf("Powtorzona druga litera klucza! Popraw przed uyciem!\n");
    return 0;
    }
  
  for(int i=0; i<size(v); i++) {
    int k1 = v[i].first;
    int k2 = v[i].second;
    for(int y=0; y<size(dane[2]); y++)
      swap(dane[2][y], dane[2][myrand() % (y+1)]);    
    
    char litera = dane[5][k1][size(dane[5][k1])-1];
    
    fprintf(f, "\\def\\kod{%s %s%c}\n",
      dane[5][k1].c_str(), dane[6][k2].c_str(),
      litera == 'a' ? 'a':
      litera == 'e' ? 'e':
      litera == 'o' ? 'e':
      litera == 'i' ? ' ':
      'y'
      );

    for(int i=1; i<4; i++)
      for(int y=0; y<size(dane[i]); y++)
        fprintf(f, "%s", dane[i][y].c_str());
  
    klucz = "";
    klucz += dane[5][k1][0];
    klucz += dane[6][k2][0];
    
    odp = "";
    
    for(int y=0; y<size(dane[2]); y++) {
      string s = dane[2][y];
      zabierzLF(s);
      odp += s[size(s)-1];
      }
    
    pytania[klucz] = dane[2];

    // printf("%s %s\n", klucz.c_str(), odp.c_str());
    }

  for(int y=0; y<size(dane[2]); y++) ileOk[dane[2][y]] = ileOdp[dane[2][y]] = 0;

  for(int y=0; y<size(dane[4]); y++)
    fprintf(f, "%s", dane[4][y].c_str());
  fclose(f);
  
  f = fopen("odp.txt", "rt");
  if(!f) {
    printf("Brak odpowiedzi (odp.txt) - konczymy\n");
    return 0;
    }
  
  // printf("Egzamin wygenerowany\n");
  // printf("Podawaj odpowiedzi w formacie np.\n");
  // printf("%s %s\n", klucz.c_str(), odp.c_str());
  // printf("Klucz (pierwsze dwie litery) to inicjaly kodu egzemplarza.\n");
  // printf("Daj kropke gdzie nie ma odpowiedzi.\n");
  
  int ile = size(dane[2]);
  
  while(!feof(f)) {
    buf[0] = 0;
    fgets(buf, 640, f);
    string s = buf;
    zabierzLF(s);
    if(s == "") continue;
    if(size(s) <= ile + 4 || s[2] != ' ' || s[ile+3] != ' ') {
      printf("zly format: %s\n", s.c_str());
      continue;
      }
    else {
      klucz = s.substr(0, 2);
      odp = s.substr(3, ile);
      string kto = s.substr(ile+4);
      
      if(kodByl.count(klucz)) printf("Powtorzony kod: %s\n", klucz.c_str());
      kodByl.insert(klucz);

      if(!pytania.count(klucz)) {
        printf("nie ma takiego klucza: %s\n", kto.c_str());
        continue;
        }

      kodStud[kto] = klucz;
      odpStud[kto] = odp;
      }
    }
  
  f = fopen("wyniki.txt", "wt");
  for(map<string, string>::iterator it = kodStud.begin(); it != kodStud.end(); it++) {
    klucz = it->second;
    odp = odpStud[it->first];

    int ok = 0, zle = 0;
    string podp;
    for(int i=0; i<size(odp); i++) {
      string pyt = pytania[klucz][i];
      podp += ppodp[pyt];
      if(odp[i] != '.') {
        ileOdp[pyt]++;
        if(odp[i] == ppodp[pyt]) ok++, ileOk[pyt]++;
        else zle++;
        }
      }
    fprintf(f, "%s %s %s +%2d -%2d %s\n", klucz.c_str(), odp.c_str(), podp.c_str(), ok, zle, it->first.c_str());
    }
  fclose(f);
  
  f = fopen("statystyki.tex", "wt");
  for(int i=0; i<5; i++) for(int y=0; y<size(dane[i]); y++) {
    if(i==1 && y == 0) fprintf(f, "\\def\\kod{statystyka wynik\\'ow}\n");

    fprintf(f, "%s", dane[i][y].c_str());
    if(i==2) fprintf(f, "(%c, %d/%d)\n", ppodp[dane[i][y]], ileOk[dane[i][y]], ileOdp[dane[i][y]]);
    }
  fclose(f);
  
  printf("wypisano statystyki i wyniki\n");
  
  return 0;
    
  // for(int i=0; i<7; i++)
  //   printf("%d\n", dane[i].size());
  }
